///100ms HMSConfig
///
///HMSConfig contains joining information of a user to a room
class HMSConfig {
  ///[userName] you want in the room you join.
  final String userName;

  ///[authToken] generated by 100ms servers.
  final String authToken;

  ///[metaData] user want to set at time of joining the meeting room.(can change later using [changeMetadata] method)
  final String? metaData;

  ///[endPoint] where you have to make post request to get token.
  final String? endPoint;
  final bool shouldSkipPIIEvents;

  ///It will capture network quality in preview
  final bool captureNetworkQualityInPreview;

  HMSConfig(
      {this.userName = 'Flutter User',
      required this.authToken,
      this.metaData,
      this.endPoint,
      this.shouldSkipPIIEvents = false,
      this.captureNetworkQualityInPreview = false});

  Map<String, dynamic> getJson() {
    return {
      'user_name': userName,
      'auth_token': authToken,
      'meta_data': metaData,
      'should_skip_pii_events': shouldSkipPIIEvents,
      'end_point': endPoint,
      'capture_network_quality_in_preview': captureNetworkQualityInPreview
    };
  }
}
